//
//  GetStarted+UIExtension.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 03.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import UIKit
import SnapKit

extension GetStartedViewController {
    /// Method used for setting up UI using SnapKit
    func setupUI() {
       
        let signUpButtonAttributedText = NSAttributedString(string: "Sign Up", attributes: [NSAttributedStringKey.font: UIFont.systemFont(ofSize: 17, weight: UIFont.Weight.bold), NSAttributedStringKey.foregroundColor: UIColor.white])
        
        let signUpButton = RoundedButton()
        signUpButton.backgroundColor = UIColor.init(color: .orangeff)
        signUpButton.setAttributedTitle(signUpButtonAttributedText, for: UIControlState.normal)
        self.view.addSubview(signUpButton)
        signUpButton.snp.makeConstraints { (make) in
            make.bottom.equalTo(-34)
            make.leading.equalTo(16)
            make.trailing.equalTo(-16)
            make.height.equalTo(54)
        }
        self.signUpButton = signUpButton
        
        let loginButtonAttributedText = NSAttributedString(string: "Log In", attributes: [NSAttributedStringKey.font: UIFont.systemFont(ofSize: 17, weight: UIFont.Weight.bold), NSAttributedStringKey.foregroundColor: UIColor.white])
        
        let loginButton = RoundedButton()
        loginButton.backgroundColor = UIColor.init(color: .orangeff)
        loginButton.setAttributedTitle(loginButtonAttributedText, for: UIControlState.normal)
        self.view.addSubview(loginButton)
        loginButton.snp.makeConstraints { (make) in
            make.bottom.equalTo(signUpButton.snp.top).offset(-12)
            make.leading.equalTo(16)
            make.trailing.equalTo(-16)
            make.height.equalTo(54)
        }
        self.loginButton = loginButton
        
        
        let titleLabel = UILabel()
        titleLabel.text = "Get Started using VaccinaDP"
        titleLabel.textColor = UIColor.black
        titleLabel.textAlignment = .center
        titleLabel.numberOfLines = 0
        titleLabel.font = UIFont.systemFont(ofSize: 16, weight: UIFont.Weight.regular)
        self.view.addSubview(titleLabel)
        titleLabel.snp.makeConstraints { (make) in
            make.leading.equalTo(24)
            make.trailing.equalTo(-24)
            make.bottom.equalTo(loginButton.snp.top).offset(-40)
        }
        self.titleLabel = titleLabel
        
        let viewCenterX = UIScreen.main.bounds.width / 2
        let logoImageView = UIImageView()
        self.view.addSubview(logoImageView)
        logoImageView.snp.makeConstraints { (make) in
            make.top.equalTo(view.safeAreaLayoutGuide.snp.top).offset(60)
            make.centerX.equalTo(viewCenterX)
            make.size.equalTo(150)
        }
        logoImageView.image = #imageLiteral(resourceName: "vaccinationLogo")
        self.logoImageView = logoImageView
    }
}

