//
//  TabBarViewController.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 03.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import UIKit

/// Common tabbar controller class for handling all tabbar controllers
class TabBarViewController: UITabBarController, UITabBarControllerDelegate {

    // MARK: - Life cycle
    override func viewDidLoad() {
        super.viewDidLoad()
    }

    init() {
        super.init(nibName: nil, bundle: nil)
    }
    
    override func loadView() {
        super.loadView()
        
        guard let homeVc = AppContainer.container.resolve(HomeViewController.self) else { return }
        let homeNav = NavigationViewController(rootViewController: homeVc)
       // homeVc.tabBarItem.selectedImage = #imageLiteral(resourceName: "homeSelected")
       // homeVc.tabBarItem.image = #imageLiteral(resourceName: "home")
        homeVc.title = "Home"
       // homeVc.tabBarItem.imageInsets = UIEdgeInsets(top: 6, left: 0, bottom: -6, right: 0)
        
        guard let profileVc = AppContainer.container.resolve(ProfileViewController.self) else { return }
        let profileNav = NavigationViewController(rootViewController: profileVc)
        profileVc.title = "Profile"

        
        tabBar.barTintColor = UIColor.white
        
       // tabBar.backgroundColor = .black
        //tabBar.tintColor = UIColor(color: .green)
        //tabBar.isTranslucent = false
        viewControllers = [homeNav, profileNav]
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
    func tabBarController(_ tabBarController: UITabBarController, shouldSelect viewController: UIViewController) -> Bool {
        if let navController = viewController as? UINavigationController, let contentController = navController.topViewController as? TableViewControlling, tabBarController.selectedViewController == viewController && navController.viewControllers.count == 1 {
            contentController.tableView.setContentOffset(.zero, animated: true)
        }
        return true
    }
}

protocol TableViewControlling {
    var tableView: UITableView! { get }
}

