//
//  AppDelegate.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 03.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import UIKit
import Firebase

/// Main application delegate
@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?

    /// Swinject container
    let container = AppContainer.container

    /// This method is called right after the application finish its start. In here should be setted the basic configs.
    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplicationLaunchOptionsKey: Any]?) -> Bool {
        AppContainer.mainRegister()
        self.setupRootViewController()
        FirebaseApp.configure()
        return true
    }
    
    /// Private methods for setting up root controller of the application.
    private func setupRootViewController() {
        
        self.window = UIWindow()
        window?.rootViewController = NavigationViewController(rootViewController: container ~ GetStartedViewController.self)
        window?.makeKeyAndVisible()
    }
}

