//
//  Themes.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 03.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import UIKit

/// Enum for custom colors
enum CustomColor:String {
    
    case orangeff = "ffa500"
    case backgroundGray = "eff1f5"
}

extension UIColor {
    
    /// Custom color init so I can write the colors only as hex string enum
    ///
    /// - Parameter color: String enum containing hex represenation of given color
    convenience init(color:CustomColor) {
        var cString = color.rawValue.trimmingCharacters(in: NSCharacterSet.whitespacesAndNewlines).uppercased() as NSString
    
        if (cString.hasPrefix("#")) {
            cString = cString.substring(from: 1) as NSString
        }
        
        let rString = cString.substring(to: 2)
        let gString = (cString.substring(from: 2) as NSString).substring(to: 2)
        let bString = (cString.substring(from: 4) as NSString).substring(to: 2)
        
        var r:CUnsignedInt = 0
        var g:CUnsignedInt = 0
        var b:CUnsignedInt = 0
        Scanner(string:rString).scanHexInt32(&r)
        Scanner(string:gString).scanHexInt32(&g)
        Scanner(string:bString).scanHexInt32(&b)
        
        self.init(red: CGFloat(r) / 255.0, green: CGFloat(g) / 255.0, blue: CGFloat(b) / 255.0, alpha: CGFloat(1))
    }
}
