//
//  UIKit+Extension.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 06.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import UIKit

extension UITableViewCell {
    /// String representaion of class name. Its need for dequing cell in tableView
    class var cellIdentifier: String {
        return NSStringFromClass(self)
    }
}

extension UITableView {
    /// Custom method for simple dequing table view cells
    ///
    /// - Parameter indexPath: IndexPath for given possition in table view
    /// - Returns: Return reusable cell
    func dequeCellForIndexPath<T>(indexPath: IndexPath) -> T where T : UITableViewCell {
        register(T.classForCoder(), forCellReuseIdentifier: T.cellIdentifier)
        return dequeueReusableCell(withIdentifier: T.cellIdentifier, for: indexPath) as! T
    }
}
    
    

