//
//  Vaccine.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 06.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import SwiftyJSON

/// Vaccine model struct
struct Vaccine {
    let id: Int
    let name: String
    let description: String
    let revaccinationInYears: Int
    var vaccinationDate: Date?
    
    /// Common object init
    init(id: Int, name: String, description: String, revaccinationInYears: Int, vaccinationDate: Date?) {
        self.id = id
        self.name = name
        self.description = description
        self.revaccinationInYears = revaccinationInYears
        self.vaccinationDate = vaccinationDate
    }
    
    /// Init object with JSON object
    ///
    /// - Parameter json: JSON with desired values
    init(with json: JSON) {
        self.id = json["id"].intValue
        self.name = json["name"].stringValue
        self.description = json["description"].stringValue
        self.revaccinationInYears = json["revaccinationInYears"].intValue
        self.vaccinationDate = nil
    }
    
}
