//
//  VaccineRecord.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 10.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import SwiftyJSON

/// Model struct for user vaccine record. This structure contains only informations important to store with user to identify desired Vaccine object.
struct VaccineRecord {
    let vaccineId: Int
    let vaccinationDate: Date?
    
    /// Common init
    init(vaccineId: Int, vaccinationDate: Date?) {
        self.vaccineId = vaccineId
        self.vaccinationDate = vaccinationDate
    }
    
    /// Set the value if VaccineRecord struct into the [String: Any] dictionary which can be writen to database as part of the User struct.
    ///
    /// - Returns: [String: Any] Dictionary of VaccineRecord properties values
    func toParameters() -> [String: Any] {
        let toReturn = [
            "vaccineId": self.vaccineId,
            "vaccinationDate": DateHelper.stringFromAPI(date: self.vaccinationDate ?? Date())
            ] as [String : Any]
        return toReturn
    }
    
}
