//
//  DateHelper.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 10.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation

/// Helper for formtting dates
struct DateHelper {
    
    /// Common dateFormatter init
    static let dateFormatter = DateFormatter()
    
    
    /// Convert given string to date based on format
    ///
    /// - Parameter string: Date in string format
    /// - Returns: Opetion formatted date
    static func dateFromAPI(string:String) -> Date? {
        dateFormatter.dateFormat = "dd.MM.yyyy"
        return dateFormatter.date(from: string)
    }
    
    /// Convert given date to string based on format
    ///
    /// - Parameter date: Date as date format
    /// - Returns: String from given date
    static func stringFromAPI(date:Date) -> String {
        dateFormatter.dateFormat = "dd.MM.yyyy"
        return dateFormatter.string(from:date)
    }
    
}
