//
//  NewVaccineTableViewCell.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 10.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import UIKit

/// Cell which display vaccination avaliable in new vaccine controller
class NewVaccineTableViewCell: UITableViewCell {
    
    // MARK: - UI Objects
    weak var label: UILabel!

    // MARK: - Life cycle
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override init(style: UITableViewCellStyle, reuseIdentifier: String?) {
        
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        
        self.backgroundColor = UIColor.init(color: .backgroundGray)
        self.selectionStyle = .none
        
        let contentView = UIView()
        contentView.backgroundColor = .white
        contentView.layer.cornerRadius = 4
        self.addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.leading.equalTo(16)
            make.trailing.equalTo(-16)
            make.top.equalTo(4)
            make.bottom.equalTo(-4)
            make.height.equalTo(54)
        }
        
        let label = UILabel()
        label.font = UIFont.systemFont(ofSize: 14, weight: UIFont.Weight.medium)
        label.textAlignment = .center
        label.textColor = .black
        label.numberOfLines = 0
        contentView.addSubview(label)
        label.snp.makeConstraints { (make) in
            make.edges.equalTo(0)
        }
        self.label = label
        
    }
    
    // MARK: - Setup methods
    /// Setup cell with given text of vaccination name
    func setupLabel(with text: String) {
        self.label.text = text
    }


}
