//
//  LoadingButton.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 03.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import UIKit
import SnapKit

/// Custom 
class LoadingButton:SelectableButton {
    
    // MARK: - UI Objects
    weak var indicator:UIActivityIndicatorView?
    
    // MARK: - Action methods
    /// Methods for start loading indicator
    func startLoading(){
        self.isUserInteractionEnabled = false
        let indicator = UIActivityIndicatorView(activityIndicatorStyle: .white)
        self.addSubview(indicator)
        indicator.snp.makeConstraints { (make) in
            make.center.equalToSuperview()
        }
        indicator.startAnimating()
        self.indicator = indicator
        self.titleLabel?.alpha = 0
        
    }
    
    /// Method for stop loading indicator
    func stopLoading() {
        self.isUserInteractionEnabled = true
        self.indicator?.stopAnimating()
        self.indicator?.removeFromSuperview()
        self.titleLabel?.alpha = 1
        
    }
    
    
}
