//
//  SelectableButton.swift
//  VakcinaDP
//
//  Created by Thomas Hamerník on 03.02.18.
//  Copyright © 2018 Thomas Hamerník. All rights reserved.
//

import Foundation
import UIKit

/// Custom button that can be selectable
class SelectableButton: UIButton {
    
    /// Override the isHeughlighted property to differentiate given states
    override var isHighlighted: Bool {
        didSet {
            if isHighlighted {
                self.alpha = 0.5
            } else {
                self.alpha = 1
            }
        }
    }
    
    /// Override the isSelected property to differentiate given states
    override var isSelected: Bool {
        didSet {
            if isSelected {
                self.alpha = 0.5
            } else {
                self.alpha = 1
            }
        }
    }
}
